/*
 7 4    
     Attiny13A
*/

.include "C:\Program Files\Atmel\AVR Studio 5.0\avrassembler\include\tn13Adef.inc"

/**************************************************************************************/
/*			                               		                              */
/**************************************************************************************/
//    
.macro	PUSHTMP
	push		tmp1
	in			tmp1,		SREG
	push		tmp1
	push		tmp2
	push		tmp3
	push		tmp4
	push		tmp5
	push		tmp
.endmacro

//    
.macro	POPTMP
	pop			tmp
	pop			tmp5
	pop			tmp4
	pop			tmp3
	pop			tmp2	
	pop			tmp1
	out			SREG,		tmp1
	pop			tmp1
.endmacro

//   
.macro	PUSHARG
	push		arg1
	push		arg2
.endmacro

//   
.macro	POPARG
	pop			arg2
	pop			arg1
.endmacro

//   
.macro	ldia
	ldi			tmp,		@1
	mov			@0,			tmp
.endmacro

//   
.macro	outi
	ldi			tmp,		@1
	out			@0,			tmp
.endmacro

//   
.macro	cpii
	ldi			tmp,		@1
	cp			@0,			tmp
.endmacro

/**************************************************************************************/
/*                                                                     */
/**************************************************************************************/


.equ	DIGIT_STROB			= DDB0	;   
.equ	SEGMENT_STROB		= DDB1	;   
.equ	DIGIT_SEGMENT_DATA	= DDB2	;    
.equ	BUTTON_PIN			= DDB3	;,     

.equ	c_maxtimer = 60
.equ	c_maxtimer2 = 142

.equ	c_second_tmrLow = 15		;       user_timer		
.equ	c_second_tmrHi	= 1			;															
.equ	c_tcnt0_tmr		= 9			;   tcnt0,   	

.equ	c_maxbtncountdown = 60

.equ	c_1		=	0b01100000
.equ	c_2		=	0b11011010
.equ	c_3		=	0b11110010
.equ	c_4		=	0b01100110
.equ	c_5		=	0b10110110
.equ	c_6		=	0b10111110
.equ	c_7		=	0b11100000
.equ	c_8		=	0b11111110
.equ	c_9		=	0b11110110
.equ	c_0		=	0b11111100
.equ	c_Empty	=	0b00000000
.equ	c_Tempr =	0b11000110
.equ	c_Tempr_preset =	0b11010110


.equ	c_C		=	0b10011100
.equ	c_L		=	0b00011100
.equ	c_H		=	0b01101110
.equ	c_minus	=	0b00000010


.equ	c_echo_start_screen	=	0
.equ	c_echo_timer		=	1
.equ	c_echo_temp			=	2
.equ	c_echo_temp_preset	=	3

.equ	c_temp_preset_default = 110	//  
.equ	c_temp_min_preset	= 90
.equ	c_temp_max_preset	= 140

.equ	c_workstatus_set	 = 0    // -    
.equ	c_workstatus_work	 = 1    //     
.equ	c_workstatus_crit_te = 2	//  /  
.equ	c_workstatus_stop	 = 3	//  


.equ	c_linear_conv		 = 35	//   80  140   
									//   .
									//  68   10   
									//  35,     C

.equ	c_critical_temp		 = 7	//     
									//      - 
									//
.equ	c_hard_crit_temp	=	170	//  
/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/
.dseg
.org	0x60

ledstr:		.byte   4			;,     
								;    
								; 3 - 

statusled:	.byte	1			;  LED 

.def	tmp1	= r16
.def	tmp2	= r17
.def	tmp3	= r18
.def	tmp4	= r19
.def	tmp5	= r20
.def	tmp		=	r24
.def	arg1	=	r21
.def	arg2	=	r22

.def	div_timer		=	r1	;  -   c_maxtimer
.def	to_echo			=	r23	;   
								;0- , 1 - , 2 -  , 3 -  
.def	div_timer2		=	r10	;   - .   
								; /
.def	temperature		=	r2	;   
.def	btnCountdown	=	r3	;      
.def	btnPressed		=	r4	; 


//   -     
.def	tmrMinutes		=	r6
.def	tmrSec			=	r7
.def	TempPreset		=	r8
.def	workStatus		=	r9	;, 0 - , 1 - , 2 - , 3 -  

.def	tmrEvntLow		=	r11	;user timer
.def	tmrEvntHi		=	r12

.def	tmrCritical		=	r13 ;,     
								;   Q0   
/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/
.cseg
.org 0
	rjmp	event_reset
	reti;	rjmp	event_button_down	; External Interrupt 0
	reti					; External Interrupt Request 0
	rjmp	event_timer		; Timer/Counter0 Overflow
	reti					; EEPROM Ready
	reti					; Analog Comparator
	reti					; Timer/Counter Compare Match A
	reti					; Timer/Counter Compare Match B
	reti					; Watchdog Time-out
	rjmp	event_adc		; ADC Conversion Complete

/**************************************************************************************/
/*                       :                            */
/**************************************************************************************/
event_reset:
	/**/
	ldi			tmp1,		RAMEND
	out			SPL,		tmp1

	/*  /*/

	outi		DDRB,		((1<<DIGIT_STROB)|(1<<SEGMENT_STROB)|(1<<DIGIT_SEGMENT_DATA)|(0<<DDB3)|(0<<DDB4))
	outi		PORTB,		0

	/* */	
	outi		TCCR0B,		((1<<CS00)|(1<<CS01)|(0<<CS02));    

	outi		TIMSK0,		(1<<TOIE0); 


	/* */
	
	/*ADMUX
			REFS0 -  0  Vcc
			ADLAR -    
			MUX -   PB4
		*/
	outi		ADMUX,		((0<<REFS0)|(1<<ADLAR)|(1<<MUX1)|(0<<MUX0))
	outi		ADCSRA,		((1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(1<<ADIE)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0))


	/* statusled*/
	ldi			YL,			low(statusled)
	ldi			YH,			high(statusled)
	ldi			tmp1,		3
	st			Y,			tmp1
	
	/*     20*/	
	ldia		div_timer,	c_maxtimer
	clr			div_timer2
	/* */
	clr			to_echo		;c_echo_start_screen

	/* */
	clr			btnCountdown

	/*   */
	ldia		tempPreset,	c_temp_preset_default

	/* */
	clr			tmrSec
	clr			tmrMinutes
	;inc			tmrMinutes

	clr			workStatus		
	;inc			workStatus

	clr			tmrEvntLow
	clr			tmrEvntHi

	sei
main:
	rjmp	main


/**************************************************************************************/
/*                          :                            */
/**************************************************************************************/
event_timer:
	PUSHTMP

	outi		TCNT0,			c_tcnt0_tmr		;  

	//   user_timer
 	inc			tmrEvntLow
	brne		ev_t_skip_tmr_evnt_low_clr
	inc			tmrEvntHi
ev_t_skip_tmr_evnt_low_clr:
	rcall		sub_dec_user_timer				;     user_timer,  

	//     timer -    
	dec			div_timer
	brne		ev_t_skip_timer
	ldia		div_timer,		c_maxtimer

	rcall		sub_timer

ev_t_skip_timer:
	clr			btnPressed
	clr			tmp2
	//    RAM,    1    tmp1 (0..3)
	ldi			YL,			low(statusled)
	ldi			YH,			high(statusled)
	ld			tmp1,		Y
	inc			tmp1
	cpi			tmp1,		4
	brlo		ev_t_skip_res

	clr			tmp1
	ldi			tmp2,		1
ev_t_skip_res:
	st			Y,			tmp1			;    RAM


	//       
	clr			tmp3
	sbrc		tmp2,		0						;  0 -   1   
	ldi			tmp3,		(1<<DIGIT_SEGMENT_DATA)	; 
	out			PORTB,		tmp3
	ori			tmp3,		(1<<DIGIT_STROB)
	out			PORTB,		tmp3
	clr			tmp3
	nop
	out			PORTB,		tmp3

	
	//       c_workstatus_crit_te  c_workstatus_stop
	//      ,   
	tst			tmp1
	brne		ev_t_skip_status
	sbrs		workStatus,	1						;    c_workstatus_crit_te  c_workstatus_stop
	rjmp		ev_t_skip_status

	//    Q0 
	push		tmp1
	push		tmp2
	ldi			tmp1,		5
	ldi			tmp2,		255
ev_t_crit_loop:
	subi		tmp2,		1
	sbci		tmp1,		0
	brcc		ev_t_crit_loop
	pop			tmp2
	pop			tmp1

ev_t_skip_status:

	//,     ,     
	tst			btnCountdown		; btnCountdown <> 0    
	brne		ev_t_skip_btn_down

	sbis		PINB,		BUTTON_PIN;  
	rjmp		ev_t_skip_btn_down

	//   -   btnPressed       . 
	mov			btnPressed,		tmp1
	ldia		btnCountdown,	c_maxbtnCountdown
	inc			btnPressed
ev_t_skip_btn_down:
	tst			btnCountdown
	breq		ev_t_skip_btn_down_dec
	dec			btnCountdown
ev_t_skip_btn_down_dec:
	//    RAM   
	ldi			YL,			low(ledstr+3)
	ldi			YH,			high(ledstr+3)
	
	sub			YL,			tmp1			;   ,    
	sbci		YH,			0

	ld			tmp1,		Y


	//        (  tmp1)
	ldi			tmp4,		8
ev_t_segment_loop:
	clr			tmp3
	ror			tmp1
	brcc		ev_t_segment_loop_no_c
	ldi			tmp3,		(1<<DIGIT_SEGMENT_DATA); 1  
ev_t_segment_loop_no_c:
	
	out			PORTB,		tmp3
	ori			tmp3,		(1<<SEGMENT_STROB)
	out			PORTB,		tmp3
	clr			tmp3
	nop
	out			PORTB,		tmp3

	dec			tmp4
	brne		ev_t_segment_loop

//   ,   
	clr			tmp1
	ori			tmp1,		(1<<DIGIT_STROB)
	out			PORTB,		tmp1
	nop
	clr			tmp1
	out			PORTB,		tmp1

	POPTMP

	tst			btnPressed
	breq		ev_t_skip_btn_down_proc_call
	rcall		sub_btn_down
ev_t_skip_btn_down_proc_call:
//  
	sbi			ADCSRA,		ADSC

	reti


/**************************************************************************************/
/*                                                                        */
/**************************************************************************************/
event_adc:
	push		tmp1
	lsr			temperature
	in			tmp1,		ADCL
	in			tmp1,		ADCH
	lsr			tmp1
	add			temperature,tmp1
	pop			tmp1						
	reti


/**************************************************************************************/
/*                                                               */
/**************************************************************************************/
/*    .    	  */
/*put_char(pos,char)                                                                  */
/*pos - (0- , 3 - )                                        */
/*char -      . A- , G - 7     */
/**************************************************************************************/
put_char:
	cli
	push		tmp1
	ldi			tmp1,		0b11111111

	ldi			YL,			low(ledstr+3)
	ldi			YH,			high(ledstr+3)
	
	sub			YL,			arg1			;   ,    
	sbci		YH,			0

	sub			tmp1,		arg2			;    -  ,  
											;   1    0.  
											;0b11111111       
	st			Y,			tmp1			;    

	pop			tmp1
	sei
	ret

/**************************************************************************************/
/*                                 0-255   .                       */
/**************************************************************************************/
/*                                                         */
/*put_number(arg1)                                                                    */
/*arg1 -                                                                  */
/*arg2 - .   4                                                        */
/**************************************************************************************/
put_number:
	PUSHTMP
	PUSHARG

	mov			tmp5,		arg2

	ldi			tmp1,		100
	ldi			tmp2,		10
	ldi			tmp3,		1

	ldi			tmp4,		1

put_num_hnd_loop:
	cp			arg1,		tmp1
	brlo		put_num_hnd_exit
	subi		tmp1,		-100
	inc			tmp4
	cpi			tmp4,		3			;      300  GG
	breq		put_num_hnd_exit
	rjmp		put_num_hnd_loop
put_num_hnd_exit:
	dec			tmp4
	subi		tmp1,		100
	sub			arg1,		tmp1
	mov			tmp1,		tmp4
	ldi			tmp4,		1

put_num_dec_loop:
	cp			arg1,		tmp2
	brlo		put_num_dec_exit
	subi		tmp2,		-10
	inc			tmp4
	rjmp		put_num_dec_loop
put_num_dec_exit:
	dec			tmp4
	subi		tmp2,		10
	sub			arg1,		tmp2
	mov			tmp2,		tmp4
	ldi			tmp4,		1

put_num_ed_loop:
	cp			arg1,		tmp4
	brlo		put_num_ed_exit
	inc			tmp4
	rjmp		put_num_ed_loop
put_num_ed_exit:
	dec			tmp4
	mov			tmp3,		tmp4

	
	mov			arg1,		tmp1
	rcall		get_code
	ldi			arg1,		0
	rcall		put_char

	mov			arg1,		tmp2
	rcall		get_code
	ldi			arg1,		1
	rcall		put_char

	mov			arg1,		tmp3
	rcall		get_code
	ldi			arg1,		2
	rcall		put_char

	mov			arg2,		tmp5
	ldi			arg1,		3
	rcall		put_char

	POPARG
	POPTMP
	ret
/**************************************************************************************/
/*                            0-99   0 - 1                         */
/**************************************************************************************/
/*                                                         */
/*put_numbers(arg1,ar2g)                                                              */
/*arg1 - 																	      */
/*arg2 -                                                                       */
/**************************************************************************************/
put_numbers:
	PUSHTMP
	PUSHARG

	//   
	ldi			tmp2,		10
	ldi			tmp3,		1

	ldi			tmp4,		1

put_nums_dec_loop:
	cp			arg1,		tmp2
	brlo		put_nums_dec_exit
	subi		tmp2,		-10
	inc			tmp4
	rjmp		put_nums_dec_loop
put_nums_dec_exit:
	dec			tmp4
	subi		tmp2,		10
	sub			arg1,		tmp2
	mov			tmp2,		tmp4
	ldi			tmp4,		1

put_nums_ed_loop:
	cp			arg1,		tmp4
	brlo		put_nums_ed_exit
	inc			tmp4
	rjmp		put_nums_ed_loop
put_nums_ed_exit:
	dec			tmp4
	mov			tmp3,		tmp4


	//  -   0  0  1 ,   1 - 2  3
		
	mov			tmp1,		arg2
	lsl			tmp1

	mov			arg1,		tmp2
	rcall		get_code
	mov			arg1,		tmp1
	rcall		put_char

	inc			tmp1

	mov			arg1,		tmp3
	rcall		get_code
	mov			arg1,		tmp1

	cpi			tmp1,		3
	brne		put_nums_ed_no_points		;    4 
	sbrs		tmp3,		0				;    -   
	ori			arg2,		0b00000001		;  - 
put_nums_ed_no_points:
	rcall		put_char

	POPARG
	POPTMP
	ret

/**************************************************************************************/
/*                                                     */
/**************************************************************************************/
sub_btn_down:
	push	tmp1
	push	tmp2

	// btnPressed   
	mov		tmp1,		btnPressed
	
	cpi		tmp1,		2
	brne	sub_btn_down_skip1
	// 1 -  
	mov		tmp1,		to_echo
	ldia	to_echo,	c_echo_temp_preset
	cp		tmp1,		to_echo
	brne	sub_btn_down_end_sub		;     -   ,  

	mov		tmp1,		TempPreset
	inc		tmp1
	cpi		tmp1,		c_temp_max_preset
	brne	sub_btn_down_skip_clr_temp
	ldi		tmp1,		c_temp_min_preset
sub_btn_down_skip_clr_temp:
	mov		TempPreset,	tmp1
	rjmp	sub_btn_down_end_sub
sub_btn_down_skip1:
	cpi		tmp1,		3
	brne	sub_btn_down_skip2
	// 2 -  
	mov		tmp1,		to_echo
	ldia	to_echo,	c_echo_timer
	cp		tmp1,		to_echo
	brne	sub_btn_down_end_sub		;     -   ,  

	mov		tmp1,		tmrSec
	mov		tmp2,		tmrMinutes
	subi	tmp1,		-30
	cpi		tmp1,		60
	brlo	sub_btn_down_skip_clr_sec
	clr		tmp1
	inc		tmp2
	cpi		tmp2,		30
	brne	sub_btn_down_skip_clr_sec
	clr		tmp2
sub_btn_down_skip_clr_sec:
	mov		tmrSec,		tmp1
	mov		tmrMinutes,	tmp2
	rjmp	sub_btn_down_end_sub
sub_btn_down_skip2:
	// 3 - .     -   .   -  
	mov		tmp1,		workStatus
	cpi		tmp1,		c_workstatus_work;   -   
	breq	sub_btn_down_end_sub
	//       -   
	mov		tmp1,		to_echo
	ldia	to_echo,	c_echo_temp
	cpi		tmp1,		c_echo_temp
	brne	sub_btn_down_end_sub
	ldia	workStatus,	c_workstatus_work
	
sub_btn_down_end_sub:
	

	pop		tmp2
	pop		tmp1
	ret

/**************************************************************************************/
/*       c_maxtimer   div_timer                  */
/**************************************************************************************/
sub_timer:
	push		tmp1
	push		tmp2


	mov			tmp1,			div_timer2
	inc			tmp1
	cpi			tmp1,			c_maxtimer2
	brne		sub_timer_skip_div2
	clr			tmp1
sub_timer_skip_div2:
	mov			div_timer2,		tmp1


	cpi			to_echo,		c_echo_start_screen
	brne		sub_timer_skip_0

	//  
	ldi			arg1,			0
	ldi			arg2,			c_C
	rcall		put_char
	ldi			arg1,			1
	ldi			arg2,			c_0
	rcall		put_char
	ldi			arg1,			2
	ldi			arg2,			c_0
	rcall		put_char
	ldi			arg1,			3
	ldi			arg2,			c_L
	rcall		put_char
	rjmp		sub_timer_end_sub
sub_timer_skip_0:
	cpi			to_echo,		c_echo_timer
	brne		sub_timer_skip_1

	// 
	mov			arg1,			tmrMinutes
	ldi			arg2,			0
	rcall	put_numbers

	mov			arg1,			tmrSec
	ldi			arg2,			1
	rcall	put_numbers

	rjmp		sub_timer_end_sub
sub_timer_skip_1:
	cpi			to_echo,		c_echo_temp
	brne		sub_timer_skip_2

	// 
	mov			arg1,		temperature
	subi		arg1,		c_linear_conv;     
	//      90 - 140 . 
	//,   80   150 - 
	cpi			arg1,		c_hard_crit_temp
	brsh		sub_timer_skip_1_show_minuses	;    


	cpi			arg1,		c_temp_min_preset - 10
	brlo		sub_timer_skip_1_show_minuses_lo;   -  LO
	
	cpi			arg1,		c_temp_max_preset + 11
	brsh		sub_timer_skip_1_show_minuses_hi;   -  HI
		
	ldi			arg2,		c_Tempr
	rcall		put_number
	rjmp		sub_timer_end_sub
sub_timer_skip_1_show_minuses:
	ldi			arg1,			0
	ldi			arg2,			c_minus
	rcall		put_char
	ldi			arg1,			1
	ldi			arg2,			c_minus
	rcall		put_char
	ldi			arg1,			2
	ldi			arg2,			c_minus
	rcall		put_char
	ldi			arg1,			3
	ldi			arg2,			c_Tempr
	rcall		put_char
	rjmp		sub_timer_end_sub
sub_timer_skip_1_show_minuses_lo:
	ldi			arg1,			0
	ldi			arg2,			c_L
	rcall		put_char
	ldi			arg1,			1
	ldi			arg2,			c_0
	rcall		put_char
	ldi			arg1,			2
	ldi			arg2,			c_Empty
	rcall		put_char
	ldi			arg1,			3
	ldi			arg2,			c_Tempr
	rcall		put_char
	rjmp		sub_timer_end_sub
sub_timer_skip_1_show_minuses_hi:
	ldi			arg1,			0
	ldi			arg2,			c_H
	rcall		put_char
	ldi			arg1,			1
	ldi			arg2,			c_1
	rcall		put_char
	ldi			arg1,			2
	ldi			arg2,			c_Empty
	rcall		put_char
	ldi			arg1,			3
	ldi			arg2,			c_Tempr
	rcall		put_char
	rjmp		sub_timer_end_sub
sub_timer_skip_2:
	cpi			to_echo,		c_echo_temp_preset
	brne		sub_timer_skip_3

	//  
	mov			arg1,		tempPreset
	ldi			arg2,		c_tempr_preset
	rcall		put_number
	rjmp		sub_timer_end_sub
sub_timer_skip_3:
	rjmp		sub_timer_exit_sub
	
sub_timer_end_sub:
	//     

	tst			workStatus					;workstatus_set = 0
	breq		sub_timer_exit_sub
	cpii		workStatus,	c_workstatus_stop
	breq		sub_timer_exit_sub		
	//   
	//,   -     div_timer -    7
	ldi			tmp1,		c_echo_temp
	sbrs		div_timer2,	7
	ldi			tmp1,		c_echo_timer
	mov			to_echo,	tmp1

	ldia		workStatus,	c_workstatus_work
	//   

	mov			tmp1,		temperature
	subi		tmp1,		c_linear_conv
	mov			tmp2,		tempPreset
	cp			tmp1,		tmp2
	brsh		sub_timer_end_sub_skip_temper_tmp_change; tmp1  tmp2 -   
														; 
	mov			tmp2,		temperature
	subi		tmp2,		c_linear_conv
	mov			tmp1,		tempPreset
sub_timer_end_sub_skip_temper_tmp_change:
	sub			tmp1,		tmp2						;    - 
	cpi			tmp1,		c_critical_temp				;   
	brlo		sub_timer_end_sub_skip_temper_critical	;  
	//,     c_critical_temp
	//  ,  ,  
	ldi			tmp1,		c_echo_timer
	sbrs		div_timer2,	7
	ldi			tmp1,		c_echo_temp
	mov			to_echo,	tmp1
	ldia		workStatus,	c_workstatus_crit_te

sub_timer_end_sub_skip_temper_critical:
	



sub_timer_exit_sub:	

	pop			tmp2
	pop			tmp1	

	ret


/**************************************************************************************/
/*                                                          */
/**************************************************************************************/
/*,  -            */
/*   .   0  workStatus           */
/*                                                                          */
/**************************************************************************************/
sub_dec_user_timer:
	tst			workStatus									; workStatus = 0 -    
	breq		sub_dec_user_timer_skip_min

	cpii		tmrEvntHi,	c_second_tmrHi
	brlo		sub_dec_user_timer_skip_min

	cpii		tmrEvntLow,	c_second_tmrLow
	brlo		sub_dec_user_timer_skip_min

	clr			tmrEvntLow
	clr			tmrEvntHi

	dec			tmrSec
	brbc		SREG_N,		sub_dec_user_timer_skip_min		; ,   
	ldia		tmrSec,		59
	dec			tmrMinutes
	brbc		SREG_N,		sub_dec_user_timer_skip_min		; ,   
	// ,   
	clr			tmrMinutes
	clr			tmrSec

	ldia		to_echo,	c_echo_timer
	ldia		workStatus,	c_workstatus_stop
sub_dec_user_timer_skip_min:
	ret


/**************************************************************************************/
/*                                                   */
/**************************************************************************************/
/* get_code(arg1) arg2                                                                */
/*arg1 -                                                          */
/*   arg2 -                                    */
/**************************************************************************************/
get_code:
	cli
	push		tmp1
	
	ldi			ZL,		low(digits*2)
	ldi			ZH,		high(digits*2)
	
	ldi			tmp1,	0
	add			ZL,		arg1
	adc			ZH,		tmp1

	lpm			arg2,	Z						;     arg2

	pop			tmp1
	sei
	ret

/**************************************************************************************/
/*                           */
/**************************************************************************************/
/* get_temperature(arg1) arg2                                                         */
/*arg1 -                                                              */
/*   arg2 -                                    */
/**************************************************************************************/
//   .   -  	
digits:
.db		c_0,	c_1,	c_2,	c_3
.db		c_4,	c_5,	c_6,	c_7
.db		c_8,	c_9

